// testvbx.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "testvbx.h"

#include "mainfrm.h"
#include "testvdoc.h"
#include "testvvw.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

LPCSTR lpszVBXFileName = "OL_VBX.VBX";

/////////////////////////////////////////////////////////////////////////////
// CTestvbxApp

BEGIN_MESSAGE_MAP(CTestvbxApp, CWinApp)
	//{{AFX_MSG_MAP(CTestvbxApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
	// Standard file based document commands
	ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTestvbxApp construction

CTestvbxApp::CTestvbxApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CTestvbxApp object

CTestvbxApp NEAR theApp;

/////////////////////////////////////////////////////////////////////////////
// CTestvbxApp initialization

BOOL CTestvbxApp::InitInstance()
{
	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

	SetDialogBkColor();        // Set dialog background color to gray
	LoadStdProfileSettings();  // Load standard INI file options (including MRU)
	EnableVBX();               // Initialize VBX support
	
	// Load the Outline VBX file
	hOLVBX = LoadVBXFile(lpszVBXFileName);

	// Register the application's document templates.  Document templates
	//  serve as the connection between documents, frame windows and views.

	CMultiDocTemplate* pDocTemplate;
	pDocTemplate = new CMultiDocTemplate(
		IDR_TESTVBTYPE,
		RUNTIME_CLASS(CTestvbxDoc),
		RUNTIME_CLASS(CMDIChildWnd),        // standard MDI child frame
		RUNTIME_CLASS(CTestvbxView));
	AddDocTemplate(pDocTemplate);

	// create main MDI Frame window
	CMainFrame* pMainFrame = new CMainFrame;
	if (!pMainFrame->LoadFrame(IDR_MAINFRAME))
		return FALSE;
	m_pMainWnd = pMainFrame;

	// create a new (empty) document
	OnFileNew();

	if (m_lpCmdLine[0] != '\0')
	{
		// TODO: add command line processing here
	}

	// The main window has been initialized, so show and update it.
	pMainFrame->ShowWindow(m_nCmdShow);
	pMainFrame->UpdateWindow();

	return TRUE;
}

int CTestvbxApp::ExitInstance()
{       
	if (hOLVBX >= HINSTANCE_ERROR)
		UnloadVBXFile(lpszVBXFileName);
		
	return CWinApp::ExitInstance();		
}

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

// Implementation
protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//{{AFX_MSG(CAboutDlg)
		// No message handlers
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// App command to run the dialog
void CTestvbxApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}

/////////////////////////////////////////////////////////////////////////////
// VB-Event registration
// (calls to AfxRegisterVBEvent will be placed here by ClassWizard)

//{{AFX_VBX_REGISTER_MAP()
	UINT NEAR VBN_OL_ADDNODE = AfxRegisterVBEvent("OL_ADDNODE");
	UINT NEAR VBN_OL_CHANGENODE = AfxRegisterVBEvent("OL_CHANGENODE");
	UINT NEAR VBN_ADDNODE = AfxRegisterVBEvent("ADDNODE");
	UINT NEAR VBN_CHANGENODE = AfxRegisterVBEvent("CHANGENODE");
	UINT NEAR VBN_INSERTNODE = AfxRegisterVBEvent("INSERTNODE");
	UINT NEAR VBN_CHANGESELECTION = AfxRegisterVBEvent("CHANGESELECTION");
	UINT NEAR VBN_DELETENODE = AfxRegisterVBEvent("DELETENODE");
	UINT NEAR VBN_INDENTNODE = AfxRegisterVBEvent("INDENTNODE");
	UINT NEAR VBN_KILLFOCUS = AfxRegisterVBEvent("KILLFOCUS");
	UINT NEAR VBN_LEFTBUTTONCLICK = AfxRegisterVBEvent("LEFTBUTTONCLICK");
	UINT NEAR VBN_MIDDLEBUTTONCLICK = AfxRegisterVBEvent("MIDDLEBUTTONCLICK");
	UINT NEAR VBN_RIGHTBUTTONCLICK = AfxRegisterVBEvent("RIGHTBUTTONCLICK");
	UINT NEAR VBN_SETFOCUS = AfxRegisterVBEvent("SETFOCUS");
	UINT NEAR VBN_VERTICALSCROLL = AfxRegisterVBEvent("VERTICALSCROLL");
//}}AFX_VBX_REGISTER_MAP

/////////////////////////////////////////////////////////////////////////////
// CTestvbxApp commands
